<?php


###############################################################
## Class Start
###############################################################
class BlogData{

  // My Variables
  protected $info;
  protected $data;
  protected $error;
  public $my;
  protected $post;
  protected $postkey;


  // construct
  public function __construct()
  {

    //
    $this->info['loca'] = dirname(__FILE__);
    $this->info['dbfile'] = $this->info['loca'].'/data/data.txt';
    $this->info['fileContent'] = file($this->info['dbfile'], FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);

    // get post url
    if (isset($_GET['id'])){
      $this->post['id'] = isset($_GET['id']) ? $_GET['id'] : '';
    }

  }


  // checker
  public function checkall(){

    // Test DB file
    if (!file_exists($this->info['dbfile'])) {
      die('Data File Not Exist');
    }

    // Get Data
    else {

      // if file empty
      if( filesize($this->info['dbfile']) == "0" ){
        $this->error['db'] = "file free";
      }

      // if have posts
      else {

        // Sort Data in array
        foreach($this->info['fileContent'] as $line_num => $line){
          // Line explode Post data
          $this->data[$line_num] = explode(" :: ", $line);

        }

        // Get Post Key
        $this->postkey = array_search($this->post['id'], array_column($this->data, '8'));

      }

    }

  }


  ###############################################################
  ## AutoMatic Site Map
  ###############################################################
  public function sitemap() {
    if(isset($_GET['post'])){
      if( $_GET['post'] == 'sitemap' ){

        header('Content-Type: application/xml; charset=utf-8');
        echo '<?xml version="1.0" encoding="UTF-8" ?>';
        echo '<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">';
        echo '<url><loc>'.$this->my['siteurl'].'blog/</loc></url>';
        // Start Loop
        if(isset($dberror)){}else{
          foreach ($this->data as $row) {
            $post_link = $this->my['siteurl'].'blog/'.trim($row[8]).'.html';
            echo '<url><loc>'.$post_link.'</loc></url>';
          }
        }
        echo '</urlset>';
       die();
      }
    }
  }

  ###############################################################
  ## Head Code
  ###############################################################
  public function head() {

    // Post Header
    if(isset($_GET['id'])):


      // check if url get right
      if( !isset($this->post['id']) || empty($this->post['id']) || $this->post['id'] == "" ){
        echo '<meta http-equiv="refresh" content="0; url='.$this->my['siteurl'].'/404.html" />';
        die();
      }

      // Slug Cleaner
      $data_slug = preg_replace('/\s/', '', $this->post['id']);

      // link sent
      $this->post['blink'] = $this->my['siteurl'].'blog/'.$data_slug.'.html';


      // Meta
      echo '<title>'.$this->data[$this->postkey][1].'</title>'."\r\n";
      echo '<meta name="description" content="'.$this->data[$this->postkey][3].'">'."\r\n";
      echo '<meta name="keywords" content="'.$this->data[$this->postkey][4].'">'."\r\n";
      // canonical
      echo '<link rel="canonical" href="'.$this->post['blink'].'" />'."\r\n";


    //  Blog Header
    else:

      echo '<link rel="canonical" href="'.$this->my['siteurl'].'blog/">'."\r\n";
      echo '<title>'.$this->my['blogtitle'].'</title>'."\r\n";
      echo '<meta name="description" content="'.$this->my['blogdescription'].'">'."\r\n";

    endif;
  }

  ###############################################################
  ## content Code
  ###############################################################
  public function content() {

    // Post Content
    if(isset($_GET['id'])):

      $this->postdata();

    // Blog Content
    else:

      $this->getallposts();

    endif;
  }


  ###############################################################
  ## Get All Posts
  ###############################################################
  public function getallposts() {

    if ( !isset($this->data) ){
      echo 'There are no posts yet';
    } else {

    // Start Loop
    foreach ( array_reverse($this->data) as $row) {

      // Post data
      $img_url = $this->my['siteurl'].'admin/'.trim($row[6]);
      $post_link = $this->my['siteurl'].'blog/'.trim($row[8]).'.html';

      ?><div class="blogbox">
          <div class="blogimg">
            <a href="<?php echo $post_link; ?>">
              <img src="<?php echo $img_url; ?>" alt="<?php echo trim($row[2]); ?>">
            </a>
          </div>
          <div class="blogmeta">
            <a href="<?php echo $post_link; ?>"><h2><?php echo trim($row[2]); ?></h2></a>
            <p><?php echo trim($row[3]); ?></p>
            <p class="read-more">
              <a href="<?php echo $post_link; ?>">Read More</a>
            </p>
          </div>
        </div>
    <?php
    }

  }

  }

  ###############################################################
  ## Get Post Data
  ###############################################################
  public function postdata(){

    ?>
    <div class="blogpost" itemscope itemtype="http://schema.org/BlogPosting">
      <div class="blog_wrapper">
        <h1 itemprop="headline"><?php echo $this->data[$this->postkey][2]; ?></h1>
        <img itemprop="image" src="<?php echo $this->my['siteurl'].'/admin/'.$this->data[$this->postkey][6]; ?>" alt="<?php echo $this->data[$this->postkey][2]; ?>">
        <?php echo html_entity_decode($this->data[$this->postkey][5]); ?>
      </div>
      <div class='socialbox'>
        <div class='social-share-btns'>
          <a class='share-btn share-btn-twitter' href='https://twitter.com/intent/tweet?text=<?php echo $this->post['blink']; ?>' rel='nofollow' target='_blank'>
            <svg role="img" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><title>Twitter icon</title><path fill="#fff" d="M23.954 4.569c-.885.389-1.83.654-2.825.775 1.014-.611 1.794-1.574 2.163-2.723-.951.555-2.005.959-3.127 1.184-.896-.959-2.173-1.559-3.591-1.559-2.717 0-4.92 2.203-4.92 4.917 0 .39.045.765.127 1.124C7.691 8.094 4.066 6.13 1.64 3.161c-.427.722-.666 1.561-.666 2.475 0 1.71.87 3.213 2.188 4.096-.807-.026-1.566-.248-2.228-.616v.061c0 2.385 1.693 4.374 3.946 4.827-.413.111-.849.171-1.296.171-.314 0-.615-.03-.916-.086.631 1.953 2.445 3.377 4.604 3.417-1.68 1.319-3.809 2.105-6.102 2.105-.39 0-.779-.023-1.17-.067 2.189 1.394 4.768 2.209 7.557 2.209 9.054 0 13.999-7.496 13.999-13.986 0-.209 0-.42-.015-.63.961-.689 1.8-1.56 2.46-2.548l-.047-.02z"/></svg>
            Tweet
          </a>
          <a class='share-btn share-btn-facebook' href='https://www.facebook.com/sharer/sharer.php?u=<?php echo $this->post['blink']; ?>' rel='nofollow' target='_blank'>
            <svg role="img" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><title>Facebook icon</title><path fill="#fff" d="M22.676 0H1.324C.593 0 0 .593 0 1.324v21.352C0 23.408.593 24 1.324 24h11.494v-9.294H9.689v-3.621h3.129V8.41c0-3.099 1.894-4.785 4.659-4.785 1.325 0 2.464.097 2.796.141v3.24h-1.921c-1.5 0-1.792.721-1.792 1.771v2.311h3.584l-.465 3.63H16.56V24h6.115c.733 0 1.325-.592 1.325-1.324V1.324C24 .593 23.408 0 22.676 0"/></svg>
            Share
          </a>
          <a class='share-btn share-btn-linkedin' href='https://www.linkedin.com/cws/share?url=<?php echo $this->post['blink']; ?>' rel='nofollow' target='_blank'>
            <svg role="img" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><title>LinkedIn icon</title><path fill="#fff" d="M20.447 20.452h-3.554v-5.569c0-1.328-.027-3.037-1.852-3.037-1.853 0-2.136 1.445-2.136 2.939v5.667H9.351V9h3.414v1.561h.046c.477-.9 1.637-1.85 3.37-1.85 3.601 0 4.267 2.37 4.267 5.455v6.286zM5.337 7.433c-1.144 0-2.063-.926-2.063-2.065 0-1.138.92-2.063 2.063-2.063 1.14 0 2.064.925 2.064 2.063 0 1.139-.925 2.065-2.064 2.065zm1.782 13.019H3.555V9h3.564v11.452zM22.225 0H1.771C.792 0 0 .774 0 1.729v20.542C0 23.227.792 24 1.771 24h20.451C23.2 24 24 23.227 24 22.271V1.729C24 .774 23.2 0 22.222 0h.003z"/></svg>
            Share
          </a>
        </div>
      </div>
    </div>
    <?php

  }


}
